<template>
  <div id="app">

    <nav>
      <div class="nav-wrapper blue darken-1">
        <a href="#" class="brand-logo center">Usuários</a>
      </div>
    </nav>

     <ul>
          <li v-for="(erro, index) of errors" :key="index"> 
              campo <b> {{ erro.field }} - {{ erro.defaultMessage }} </b>
          </li>
      </ul>

    <div class="container">

      <form @submit.prevent="salvar">

          <label>Nome</label>
          <input type="text" placeholder="Nome" v-model="usuario.nome">

          <label>Sobrenome</label>
          <input type="text" placeholder="Sobrenome" v-model="usuario.sobrenome">

          <label>E-mail</label>
          <input type="email" placeholder="E-mail" v-model="usuario.email">

          <label>Senha</label>
          <input type="password" placeholder="Senha" v-model="usuario.senha">

          <button class="waves-effect waves-light btn-small">Salvar<i class="material-icons left">save</i></button>

      </form>

      <table>

        <thead>

          <tr>
            <th>NOME</th>
            <th>SOBRENOME</th>
            <th>E-MAIL</th>
            <th>SENHA</th>
            <th>OPÇÕES</th>
          </tr>

        </thead>

        <tbody>

          <tr v-for="usuario of usuarios" :key="usuario.id">
            <td> {{ usuario.nome }} </td>
            <td> {{ usuario.sobrenome }} </td>
            <td> {{ usuario.email }} </td>
            <td> {{ usuario.senha }} </td>
            <td>
              <button @click="editar(usuario)" class="waves-effect btn-small blue darken-1"><i class="material-icons">create</i></button>
              <button @click="remover(usuario)" class="waves-effect btn-small red darken-1"><i class="material-icons">delete_sweep</i></button>
            </td>

          </tr>

        </tbody>
      
      </table>

    </div>

  </div>
</template>

<script>

import Usuario from '../service/usuarios';

  export default {

  data(){
    return {
      usuario: {
        id: '',
        nome: '',
        sobrenome: '',
        email: '',
        senha: ''
      },

      usuarios: [],
      errors: []
    }
  },

  mounted(){
      this.listar()
    },

  methods: {
    listar() {
    Usuario.listar().then(resposta => {
      this.tipos = resposta.data
    })
  },

  salvar () {
      if(!this.usuario.id){
        Usuario.salvar(this.usuario).then(resposta => {
          this.usuario = {}
          alert('Usuário cadastrado com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }else{
      Usuario.atualizar(this.usuario).then(resposta => {
          this.usuario = {}
          alert('Usuário atualizado com sucesso!')
          this.listar()
          this.errors = []
        }).catch(e => {
          this.errors = e.response.data.errors
      })
    }

  },

  editar(usuario){
    this.usuario = usuario
  },

  remover(usuario){
    if(confirm('Deseja excluir esse usuário?')){
      Usuario.apagar(usuario).then(resposta => {
        this.listar();
        this.errors = []
      }).catch(e => {
        this.errors = e.response.data.errors
      })
    }
  }
}
}

</script>